// utility function to retrieve an expiration date in proper
// format; pass three integer parameters for the number of days, hours,
// and minutes from now you want the cookie to expire (or negative
// values for a past date); all three parameters are required,
// so use zeros where appropriate
function getExpDate(days, hours, minutes) {
    var expDate = new Date( );
    if (typeof days == "number" && typeof hours == "number" && 
        typeof minutes == "number") {
        expDate.setDate(expDate.getDate( ) + parseInt(days));
        expDate.setHours(expDate.getHours( ) + parseInt(hours));
        expDate.setMinutes(expDate.getMinutes( ) + parseInt(minutes));
        return expDate.toGMTString( );
    }
}
   
// utility function called by getCookie( )
function getCookieVal(offset) {
    var endstr = document.cookie.indexOf (";", offset);
    if (endstr == -1) {
        endstr = document.cookie.length;
    }
    return unescape(document.cookie.substring(offset, endstr));
}
   
// primary function to retrieve cookie by name
function getCookie(name) {
    var arg = name + "=";
    var alen = arg.length;
    var clen = document.cookie.length;
    var i = 0;
    while (i < clen) {
        var j = i + alen;
        if (document.cookie.substring(i, j) == arg) {
            return getCookieVal(j);
        }
        i = document.cookie.indexOf(" ", i) + 1;
        if (i == 0) break; 
    }
    return "";
}
   
// store cookie value with optional details as needed
function setCookie(name, value, expires, path, domain, secure) {
    document.cookie = name + "=" + escape (value) +
        ((expires) ? "; expires=" + expires : "") +
        ((path) ? "; path=" + path : "") +
        ((domain) ? "; domain=" + domain : "") +
        ((secure) ? "; secure" : "");
}
   
// remove the cookie by setting ancient expiration date
function deleteCookie(name,path,domain) {
    if (getCookie(name)) {
        document.cookie = name + "=" +
            ((path) ? "; path=" + path : "") +
            ((domain) ? "; domain=" + domain : "") +
            "; expires=Thu, 01-Jan-70 00:00:01 GMT";
    }
}

//WebJeeves Expires Duration in minutes
var loginExpire_Minutes = 60;


function set_LoginCookie(expireTime)
{
	expDate = getExpDate(0, 0, parseInt(expireTime));
	setCookie("LoginCookie", "TRUE" , expDate);
}


function reset_LoginCookie(expireTime)
{
	var expDate;
	var loginCookie = getCookie("LoginCookie");	
	expDate = getExpDate(0, 0, parseInt(expireTime));
	setCookie("userType", getCookie("userType"), expDate);
	setCookie("LoginCookie", loginCookie , expDate);
	setCookie("LoginSuccess",getCookie("LoginSuccess"), expDate);	
}

function check_LoginCookie()
{
	var loginCookie = getCookie("LoginCookie");
	
	if(loginCookie == "TRUE" && loginCookie != "")
		return true;
	else
		return false;
}

//Used to make login expired
function disable_LoginCookie()
{
	var expDate;
	var loginCookie = getCookie("LoginCookie");
	expDate = getExpDate(-1, 30, 0);
	setCookie("LoginCookie", "FALSE" , expDate);
}

//Used to set login cookie for duration specified by loginExpire_Minutes
function enable_LoginCookie()
{
	set_LoginCookie(loginExpire_Minutes);
}

function refresh_LoginCookie()
{
	reset_LoginCookie(loginExpire_Minutes);
}

//Used to process login cookie, if cookie expired switch to login expires page otherwise refresh the login cookie expires duration
function process_LoginCookie()
{	
	if(check_LoginCookie() == false)
	{
		DeleteCookiesAndLogout();
		return false;
	}
	else
	{
		reset_LoginCookie(loginExpire_Minutes);
		refreshOtherCookie();
		return true;
	}
}

function refreshOtherCookie()
{	
	var expDate = getExpDate(0, 1, 59);		
	setCookie("SetupMode", getCookie("SetupMode"), expDate);	
	setCookie("userType", getCookie("userType"), expDate);
	setCookie("Language", getCookie("Language"), expDate);
	setCookie("UserLanguage", getCookie("UserLanguage"), expDate);
	setCookie("ProductName", getCookie("ProductName"), expDate);
	setCookie("adminLangWeb",getCookie("adminLangWeb"), expDate);
	setCookie("UserLangWeb",getCookie("UserLangWeb"), expDate);	
	setCookie("ActiveLink", getCookie("ActiveLink"), expDate);
	setCookie("MoreLessMode", getCookie("MoreLessMode"), expDate);
	setCookie("Popup", getCookie("Popup"), expDate);
}
function resetOtherCookie()
{	
	var expDate = getExpDate(0, 1, 59);		
	setCookie("SetupMode", "false", expDate);		
	setCookie("userType", "NoOne", expDate);	
	setCookie("Language","English" , expDate);
	setCookie("UserLanguage","English", expDate);
	setCookie("ProductName","NoOne" , expDate);
	setCookie("adminLangWeb","English", expDate);
	setCookie("UserLangWeb","English", expDate);	
	setCookie("ActiveLink", "", expDate);
	setCookie("MoreLessMode","Less", expDate);
	setCookie("Popup","false" , expDate);
}	
function DeleteCookiesAndLogout()
{
	var expDate = getExpDate(-1, 30, 0);
	setCookie("userType", "NoOne", expDate);
	setCookie("Language", "NoOne", expDate);
	setCookie("UserLanguage", "NoOne", expDate);
	setCookie("ProductName", "NoOne", expDate);
	setCookie("adminLangWeb","NoOne", expDate);
	setCookie("UserLangWeb","NoOne", expDate);	
	setCookie("ActiveLink", "", expDate);
	setCookie("SetupMode", "false", expDate);
	setCookie("Popup", "false", expDate);
	setCookie("MoreLessMode","Less", expDate);
	window.top.location = "startup.html";
}

function ActivateLink(linkName)
{
	var expDate = getExpDate(0, 0, 59);
	setCookie("ActiveLink", linkName, expDate);
	top.MainMenu.SelectLink();
}