#!/bin/sh

# This script is called from application

# Send Signal to application using write to passed file name

# TLS_CERT_GENERATION_IDLE			0
# TLS_CERT_GENERATION_IN_PROGRESS		1
# TLS_CERT_GENERATED				2
# TLS_NEW_CERT_GENERATION_NOT_REQUIRED		3
# TLS_CERT_GENERATION_FAIL			4

echo 1 > $2

# First remove the demoCA folder.
if [ -d /root/scripts/demoCA ]
then
	rm -rf /root/scripts/demoCA
	rm -rf /root/scripts/new*
fi

# First remove the Old server Certificat file
if [ -f /matrix/cert/server.pem ]
then
	rm /matrix/cert/server.pem
fi


if [ ! -f /ramdisk/lib/apps/openssl ]
then
	# Remove the certificate related files and folder from /usr/ssl/.
	rm -rf /usr/ssl/demoCA
	rm -rf /usr/ssl/new*

	#Remove the Old ca and server Certificat files
	rm /matrix/cert/cacert.pem
	rm /matrix/cert/server.pem
	echo 4 > $2
	echo "openssl File Not Found."

#create a certificate to call CA.sh
elif [ -f /root/scripts/CA.sh ]
then
	#go to CA.sh file
	cd /root/scripts

	#run the CA.sh file

	# create the cacert.pem only not present /usr/ssl/demo folder
	if [ ! -d /usr/ssl/demoCA ]
	then
		#first remove old CA certificate
		rm -f /matrix/cert/cacert.pem
		
		#create the new CA certificate
		./CA.sh -newca $1
	elif [ ! -f /matrix/cert/cacert.pem ]
	then
		#create the new CA certificate
		./CA.sh -newca $1
	else
		# if present then move the demo folder and files
		cp -r /usr/ssl/demoCA /root/scripts/
		cp /usr/ssl/new* /root/scripts/
	fi

	#create the new server certificate
	./CA.sh -newreq $1
	./CA.sh -sign $1

	# Checking certificate files are Generated Or Not
	isCertificateFail="n"
	if [ ! -f newkey.pem ]
	then
		isCertificateFail="y"

	elif [ ! -f newcert.pem ]
	then
		isCertificateFail="y"

	elif [ ! -f demoCA/cacert.pem ]
	then
		isCertificateFail="y"

	fi

	if [ "$isCertificateFail" = "y" ]
	then
		isCertificateFail="n"
		echo 4 > $2

		# Remove the certificate related files and folder from /usr/ssl/.
		rm -rf /usr/ssl/demoCA
		rm -rf /usr/ssl/new*

		#Remove the New generated files and folder
		rm -rf demoCA
		rm -rf new*

		#Remove the Old ca and server Certificat files
		rm /matrix/cert/cacert.pem
		rm /matrix/cert/server.pem

		echo "Certificate Generation Fail"
		exit
	fi

	#After this OpenSSL certificat has been created and concat the newkey.pem and newcert.pem to server.pem.
	cat newkey.pem > /matrix/cert/server.pem
	cat newcert.pem >> /matrix/cert/server.pem

	#Copy the demoCA/cacert.pem to /matrix/scripts/ only not /usr/ssl/demo folder
	if [ ! -f /matrix/cert/cacert.pem ]
	then
		cp demoCA/cacert.pem /matrix/cert/
	fi

	# Remove and mv the demoCA folder to /usr/ssl/.
	rm -rf /usr/ssl/demoCA
	rm -rf /usr/ssl/new*

	mv /root/scripts/demoCA /usr/ssl/
	mv /root/scripts/new* /usr/ssl/

	# Certificat has been generated successfuly
	echo 2 > $2

else
	echo 4 > $2
	echo "CA.sh File Not Found."

fi
